# Examples for Tutorial 7 #
How to use these examples.

## General ##
1. Check your package.json looks something like this:<br />
```
{
  "name": "hf-examples-07",
  "version": "0.0.1",
  "dependencies": {
    "express": "^4.10.4",
    "body-parser": "~1.8.1",
    "jade": "~1.6.0"
  }
}
```
2. Use the included `package.json` file and type in a terminal `$ npm install` (without the dollar).
3. Each `*.js` file is a runnable node app. Use either `$ node {filename}` or `$ nodejs {filename}` to run it.



## 01\_basicServer.js ##
```
$ node 01_basicServer.js
```

## 02\_basicExpress.js ##
Make sure that Express is installed and the `express`
 directory exists in the `node_modules` directory:

```
$ npm install express
```
Alternatively, use a `package.json` file and do an `$ npm install`.
```
$ node 01_basicServer.js
```

## 03\_middlewareChain.js ##
You should see in this example that once the response has been sent back to the client, all other middleware functions are void.
```
$ node 03_middlewareChain.js
```

## 04\_routerExample.js ##
Shows two exemplary routes.
```
$ node 04_routerExample.js
```
### 04\_routerExample-Solution.js ###
This is the solution for the interactivity task. Most importantly: Make sure to add the body-parser module to the dependencies list and perform an `$ npm install`.

Use [Postman](https://chrome.google.com/webstore/detail/postman-rest-client/fdmmgilgnpjigdojojpjoooidkmcomcm) to test your POST requests. Make sure to add the following Header:

Content-type: application/json

in the headers section.

Then, you can use the x-www-form-urlencoded parameters to test your solution.

## 05\_jsCodeInJade.jade ##
This file is not runnable, but you can render it, if you wish. `06_template.js` shows you how.

## 06\_template.js ##
This app shows you how to render a template. Make sure to add jade to your dependencies
list or install jade locally. Play around a little by passing different values for the
`templateParamters` variable.
### 06\_template-Solution.jade ###
A very small solution for the second interactivity slide
